// Arup Guha
// 3/14/2013
// Solution to COP 3503 Program #5C: Stick Splitting

import java.util.*;

public class sticks {
	
	public final static int UNKNOWN = -1;
	
	public static void main(String[] args) {
		
		Scanner stdin = new Scanner(System.in);
		
		// Go through each case.
		int numCases = stdin.nextInt();
		for (int loop=0; loop<numCases; loop++) {
			
			int length = stdin.nextInt();
			int numCuts = stdin.nextInt();
			
			// Set up boundaries, including endpoints.
			int[] cuts = new int[numCuts+2];
			cuts[0] = 0;
			cuts[cuts.length-1] = length;
			
			// Read in the rest.
			for (int i=1; i<=numCuts; i++)
				cuts[i] = stdin.nextInt();
				
			// Initialize DP array (for memoization).
			int[][] dp = new int[cuts.length][cuts.length];
			for (int i=0; i<dp.length; i++)
				Arrays.fill(dp[i], UNKNOWN);
				
			System.out.println(solve(cuts, 0, cuts.length-1, dp));
		}
	}
	
	public static int solve(int[] cuts, int start, int end, int[][] dp) {
		
		// Trivial case, no cuts.
		if (start >= end-1) return 0;
		
		// We've solved this case before.
		if (dp[start][end] != UNKNOWN)
			return dp[start][end];
			
		// Try each split, updating best.
		int best = Integer.MAX_VALUE;
		for (int split=start+1; split<end; split++) {
			int cost = cuts[end] - cuts[start] + solve(cuts, start, split, dp) + solve(cuts, split, end, dp);
			if (cost < best)
				best = cost;
		}
		
		// Store answer and return.
		dp[start][end] = best;
		return best;
	}
}